/*
	EzGraph-Win32
	Ver0.11
	2011.01.06
	Kazuhiko Ohno
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include<windows.h>
#include<shlwapi.h>
#include"EzGraph.h"

// printf()ŏo͂łő啶
#define PRINTF_MAX_LEN 8192

#define InitFill()	    HBRUSH hbrush, hbrush_old; 
#if 1
#define BeginFill()	    hbrush = CreateSolidBrush(pen_color); \
                        hbrush_old = SelectObject(hdc, hbrush); 
#define EndFill()	    SelectObject(hdc, hbrush_old); \
						DeleteObject(hbrush);
#else
#define BeginFill()    
#define EndFill()      
#endif

typedef struct {
	int key;
	int flag;
	int is_down;
} event_key_t;

typedef struct {
	int x;
	int y;
	unsigned int button;
	int flag;
} event_mouse_t;

char ezkey_map[32] = {0};

typedef struct {
	unsigned char vk;
	unsigned short ezk;
} vk2ezk_t;

vk2ezk_t vk2ezk[] = {
	{VK_BACK, EZ_BackSpace}, // 08
	{VK_TAB, EZ_Tab},        // 09
	{VK_RETURN, EZ_Return},  // 0D
	{VK_ESCAPE, EZ_Escape},  // 1B
	{VK_SPACE, EZ_space},    // 20
	{VK_PRIOR, EZ_Page_Up},  // 21 Page Up
	{VK_NEXT, EZ_Page_Down}, // 22 Page Down
	{0x30,EZ_0},             // 30
	{0x31,EZ_1},             // 31
	{0x32,EZ_2},             // 32
	{0x33,EZ_3},             // 33
	{0x34,EZ_4},             // 34
	{0x35,EZ_5},             // 35
	{0x36,EZ_6},             // 36
	{0x37,EZ_7},             // 37
	{0x38,EZ_8},             // 38
	{0x39,EZ_9},             // 39
	{0x41,EZ_A},             // 41
	{0x42,EZ_B},             // 42
	{0x43,EZ_C},             // 43
	{0x44,EZ_D},             // 44
	{0x45,EZ_E},             // 45
	{0x46,EZ_F},             // 46
	{0x47,EZ_G},             // 47
	{0x48,EZ_H},             // 48
	{0x49,EZ_I},             // 49
	{0x4A,EZ_J},             // 4A
	{0x4B,EZ_K},             // 4B
	{0x4C,EZ_L},             // 4C
	{0x4D,EZ_M},             // 4D
	{0x4E,EZ_N},             // 4E
	{0x4F,EZ_O},             // 4F
	{0x50,EZ_P},             // 50
	{0x51,EZ_Q},             // 51
	{0x52,EZ_R},             // 52
	{0x53,EZ_S},             // 53
	{0x54,EZ_T},             // 54
	{0x55,EZ_U},             // 55
	{0x56,EZ_V},             // 56
	{0x57,EZ_W},             // 57
	{0x58,EZ_X},             // 58
	{0x59,EZ_Y},             // 59
	{0x5A,EZ_Z},             // 5A
	// eL[EtL[ƂɐL[EZ_0-EZ_9Ƃ݂Ȃ
	{VK_NUMPAD0,EZ_0},       // 60
	{VK_NUMPAD1,EZ_1},       // 61
	{VK_NUMPAD2,EZ_2},       // 62
	{VK_NUMPAD3,EZ_3},       // 63
	{VK_NUMPAD4,EZ_4},       // 64
	{VK_NUMPAD5,EZ_5},       // 65
	{VK_NUMPAD6,EZ_6},       // 66
	{VK_NUMPAD7,EZ_7},       // 67
	{VK_NUMPAD8,EZ_8},       // 68
	{VK_NUMPAD9,EZ_9},       // 69

	{VK_LEFT, EZ_Left},
	{VK_UP, EZ_Up},
	{VK_RIGHT, EZ_Right},
	{VK_DOWN, EZ_Down},
};
#define VK2EZK_NUM (sizeof(vk2ezk)/sizeof(vk2ezk_t))

unsigned short vk2ezk_table[256];

#define EVENT_QUEUE_SIZE 16

event_key_t event_key_queue[EVENT_QUEUE_SIZE];
int event_key_queue_head = 0;
int event_key_queue_tail = 0;


event_mouse_t event_mouse = {0, 0, 0, 0};
event_mouse_t event_mouse_release = {0, 0, 0, 0};

// COLORREFBGȐȂ̂ŁÃ}Nŕϊ
#define RGB2COLORREF(rgb) (((rgb) & 0xff) << 16) + ((rgb) & 0xff00) + (((rgb) & 0xff0000) >> 16)


// CEBhẼnhێp
HWND win_hwnd;
HDC win_hdc = NULL;
COLORREF pen_color;

// `ΏۃReLXg
//HDC draw_hdc = NULL;
// 
HDC buf_hdc[2] = {NULL, NULL};
HBITMAP buf_bmp[2] = {NULL, NULL};
int onScreen = 0, offScreen = 1;

int client_width = EzDefaultWidth;
int client_height = EzDefaultHeight;
int fontSize = EzDefaultFontSize;


DWORD timerh_nexttime = 0;
EzTimerHandler timerh_func = NULL;
unsigned long timerh_ms = 1000;
EzKeyHandler keyh_func = NULL;
EzKeyHandler key_releaseh_func = NULL;
EzMouseHandler mouseh_func = NULL;
EzMouseHandler mouse_releaseh_func = NULL;

// EzShowBuffer^ɂȂAWM_PAINTŋUɖ߂
//int showBufferF = 0;

// EzExitEventLoop()Ő^ɂȂAEventLoop𔲂
int exitF = 0;
// 0ȂBȂ֐łxItCrbg}bvɂ
//int forceOffline = -1;
//int forceOffline = 0;

extern _EzName2RGB_t _EzName2RGB[];
int name2rgb_num = 0;

HBITMAP xpm_bmp[XPM_MAX*2];
int xpm_bmp_num = 0;

#define PI 3.14159265359

// AdjustWindowRectCreateWindowƓX^CKvȂ̂ŁAŃ}NĂ
// TCYύX֎~̂߁AWS_THICKFRAMEO
// ő剻֎~̂߁AWS_MAXIMIZEBOXO
#define WINDOW_STYLE (WS_OVERLAPPEDWINDOW & (~WS_THICKFRAME) & (~WS_MAXIMIZEBOX))

LOGFONT logFont;


HMENU mainMenu, viewMenu;

typedef enum {
	mid_quit,
	mid_view,
	mid_console,
} mid_t;

// WinMainŃ[Umain֐Ăяo߁Avg^Cv錾Ă
int main();

int _EzDrawPoint(HDC hdc, int x, int y);
int _EzDrawLine(HDC hdc, int x1, int y1, int x2, int y2);
int _EzDrawString(HDC hdc, int x, int y, char *s);
int _EzDrawBox(HDC hdc, int x1, int y1, int x2, int y2);
int _EzFillBox(HDC hdc, int x1, int y1, int x2, int y2);
int _EzDrawCircle(HDC hdc, int x, int y, unsigned int r);
int _EzFillCircle(HDC hdc, int x, int y, unsigned int r);
int _EzDrawArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2);
int _EzFillArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2);
void _conv_arc_param(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2,
					 int *left, int *top, int *right, int *bottom, int *sx, int *sy, int *ex, int *ey);
int _EzClear(HDC hdc);
int _EzFillPolygon(HDC hdc, int num, int *poly);
void _EzDeleteImage(void);
void _EzPut(HDC hdc, int x, int y, EzImage img);

LRESULT CALLBACK WindowProc(HWND,UINT,WPARAM,LPARAM);

// R\[֌W
int enableConsole = 0;
HWND consoleHwnd = NULL;
#define CONSOLE_LINES 25
#define CONSOLE_LENGTH 80
#define CONSOLE_FONTSIZE 14
#define CONSOLE_MARGIN 4
#define CONSOLE_WIDTH (CONSOLE_FONTSIZE * CONSOLE_LENGTH / 2 + CONSOLE_MARGIN*2)
#define CONSOLE_HEIGHT (CONSOLE_FONTSIZE * CONSOLE_LINES + CONSOLE_MARGIN*2)
#define CONSOLE_DWEXSTYLE (WS_EX_LEFT)
#define CONSOLE_DWSTYLE (WS_CAPTION | WS_BORDER | WS_VISIBLE)
int console_x = 640;
int console_y = 100;
void _EzCreateConsole(void);
void _EzDestroyConsole(void);
LRESULT CALLBACK ConsoleProc(HWND,UINT,WPARAM,LPARAM);
int _EzPrintf(char *fmt, ...);
int _EzPuts(char *s);
int _EzPutLine(char *s);
char console_text[CONSOLE_LINES][CONSOLE_LENGTH+1];
int console_tail = 0;
// console_tailsɏĂ镶
// ꂪ1ȏ̏ꍇA܂p
// OŉsĂ΁Aconsole_tails͐VKsconsole_len==0
int console_len = 0;
LOGFONT consoleFont;


int WINAPI WinMain(HINSTANCE hInstance,
		   HINSTANCE hPrevInstance,
		   LPSTR lpCmdLine,
		   int nShowCmd)
{
    HWND hwnd;
	WNDCLASSEX wc;
//	HBRUSH hBrush;
//    HMENU mainMenu;
	char exePath[MAX_PATH];
	char *argv[ARG_MAX];
    int argc;
	int i;

	wc.cbSize = sizeof(WNDCLASSEX);
    // EBhEDC̑iIɂ邽OWNDCw
	wc.style = CS_OWNDC;
    wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName =NULL;
    wc.lpszClassName="EzGraphWin32Class";
	wc.hIconSm = NULL;    
	if (RegisterClassEx(&wc) == 0){
        return 0;
	}

	hwnd = CreateWindowEx(WS_EX_APPWINDOW, wc.lpszClassName, "EzGraph-Win32", WINDOW_STYLE,
		      100, 100, client_width, client_height, NULL, NULL, hInstance, NULL);

    if (hwnd == NULL)
        return 0;
	win_hwnd = hwnd;

	// ConsoleEBhENX
	wc.cbSize = sizeof(WNDCLASSEX);
    // EBhEDC̑iIɂ邽OWNDCw
	wc.style = CS_OWNDC;
    wc.lpfnWndProc = ConsoleProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "EzGraphConsoleClass";
	wc.hIconSm = NULL;    
	if (RegisterClassEx(&wc) == 0){
        return 0;
	}

	// ----- j[֌W̏
	mainMenu = CreateMenu();
	viewMenu = CreatePopupMenu();

	AppendMenu(mainMenu, MF_STRING, mid_quit, "I(&Q)");
	AppendMenu(mainMenu, MF_STRING | MF_POPUP, (UINT)viewMenu, "\(&V)");
	AppendMenu(viewMenu, MF_STRING, mid_console, "R\[(&C)");
    SetMenu(win_hwnd, mainMenu);

    ShowWindow(hwnd, SW_SHOW);
    UpdateWindow(hwnd);

	win_hdc = GetDC(win_hwnd);

	// ^Cgo[glđ傫𒲐
	// ItCrbg}bv͂̒ō̂ŁAuVȂǂ̐ݒ̒ł
	EzOpenWindow(EzDefaultWidth, EzDefaultHeight);

    // _Ezname2rgbrgb.cŒ`ĂÓIɃTCY擾łȂ̂
	// œIɒׂ
	while (_EzName2RGB[name2rgb_num].name != NULL){
		name2rgb_num ++;
	}

	for (i = 0 ; i < VK2EZK_NUM ; i++){
		vk2ezk_table[vk2ezk[i].vk] = vk2ezk[i].ezk;
	}

	GetModuleFileName(NULL, exePath, MAX_PATH);
	_backSlash2Slash(exePath);
    argv[0] = exePath;
	argc = 1;
    main(argc, argv);
	return 0;
}


LRESULT CALLBACK WindowProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
//    static HBITMAP screenBuffer = NULL;
	PAINTSTRUCT ps;
    HDC hdc = NULL;
	int ezkey, code, key, i;
	switch (message) {
	case WM_LBUTTONDOWN:
		event_mouse.flag = -1;
		event_mouse.button = 1;
		event_mouse.x = LOWORD(lparam);
		event_mouse.y = HIWORD(lparam);
		return 0;
	case WM_MBUTTONDOWN:
		event_mouse.flag = -1;
		event_mouse.button = 2;
		event_mouse.x = LOWORD(lparam);
		event_mouse.y = HIWORD(lparam);
		return 0;
	case WM_RBUTTONDOWN:
		event_mouse.flag = -1;
		event_mouse.button = 3;
		event_mouse.x = LOWORD(lparam);
		event_mouse.y = HIWORD(lparam);
		return 0;
	case WM_LBUTTONUP:
		event_mouse_release.flag = -1;
		event_mouse_release.button = 1;
		event_mouse_release.x = LOWORD(lparam);
		event_mouse_release.y = HIWORD(lparam);
		return 0;
	case WM_MBUTTONUP:
		event_mouse_release.flag = -1;
		event_mouse_release.button = 2;
		event_mouse_release.x = LOWORD(lparam);
		event_mouse_release.y = HIWORD(lparam);
		return 0;
	case WM_RBUTTONUP:
		event_mouse_release.flag = -1;
		event_mouse_release.button = 3;
		event_mouse_release.x = LOWORD(lparam);
		event_mouse_release.y = HIWORD(lparam);
		return 0;
	case WM_KEYDOWN:
		ezkey = vk2ezk_table[wparam];
        code = ezkey & 0xff;
        ezkey_map[(code >> 3)] |= (1 << (code & 0x07));
        // J[\L[ȊO̓AXL[R[hɒ
		if (ezkey < EZ_Left || ezkey > EZ_Down){
			key = code;
			// Ƃ肠pL[͏ɂĂ
			key = tolower(key);
		}
		else {
			key = ezkey;
		}
		event_key_queue[event_key_queue_tail].key = key;
		event_key_queue[event_key_queue_tail].is_down = -1;
		event_key_queue_tail = (event_key_queue_tail + 1) % EVENT_QUEUE_SIZE;
		return 0;
	case WM_KEYUP:
		ezkey = vk2ezk_table[wparam];
        code = ezkey & 0xff;
		ezkey_map[(code >> 3)] &= (0xff - (1 << (code & 0x07)));
        // J[\L[ȊO̓AXL[R[hɒ
		if (ezkey < EZ_Left || ezkey > EZ_Down){
			key = code;
			// Ƃ肠pL[͏ɂĂ
			key = tolower(key);
		}
		else {
			key = ezkey;
		}
	
		event_key_queue[event_key_queue_tail].key = key;
		event_key_queue[event_key_queue_tail].is_down = 0;
		event_key_queue_tail = (event_key_queue_tail + 1) % EVENT_QUEUE_SIZE;
		return 0;
	case WM_CLOSE:
		if (MessageBox(win_hwnd, "vOI܂H", "mF", MB_ICONQUESTION|MB_YESNO) == IDNO){
			return 0;
		}
		// DefWindowProcWM_CLOSEnƃN[Ys
		break;
	case WM_DESTROY:
                PostQuitMessage(0);
		_EzDeleteImage();
		for (i = 0 ; i < 2 ; i++){
	  		DeleteObject(buf_bmp[i]);
			DeleteDC(buf_hdc[i]);
		}
		ReleaseDC(win_hwnd, win_hdc);  // win_hdcGetDCŎ擾̂ReleaseDC
        return 0;
	case WM_PAINT:
		// OWNDCwin_hdcDC펞ێĂ邪A
		// ̗̈L̂BeginPaint/EndPaintĂԕKv
		hdc = BeginPaint(win_hwnd, &ps);
        BitBlt(win_hdc, 0, 0, client_width, client_height, buf_hdc[onScreen], 0, 0, SRCCOPY);
		EndPaint(win_hwnd, &ps);
		return 0;
                // WM_PAINTŖɍĕ`悷ȂÃnh͕sv
                //	case WM_ACTIVATE:
                // ItC`̏ꍇ́A
                // EBhEANeBuɂȂƂ
                // obt@]`悷
                // !!! mANeBuɂȂƂ̃nhĂ΂̂ŁA
                // wparam̒lmFăANeBûݕ`悵قǂ
                //                if (forceOffline){
                //                    EzShowBuffer();
                //                }
                //                return 0;
	case WM_COMMAND:
		// j[WM_COMMAND̏
		if (lparam == 0){
			switch (LOWORD(wparam)) {
         	case mid_quit:
                SendMessage(win_hwnd, WM_CLOSE, 0, 0);
				break;
         	case mid_console:
				if (enableConsole){
					_EzDestroyConsole();
				}
				else {
					_EzCreateConsole();
				}
				break;
			default:
				break;
			}
		}
		return 0;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}


void _EzCreateConsole(void){
	RECT cRect;
	MENUITEMINFO menuItemInfo;
	HINSTANCE hInstance;
	HDC hdc;

    hInstance = (HINSTANCE)GetWindowLong(win_hwnd, GWL_HINSTANCE);

	SetRect(&cRect, 0, 0, CONSOLE_WIDTH, CONSOLE_HEIGHT);
	AdjustWindowRectEx(&cRect, CONSOLE_DWSTYLE, FALSE, CONSOLE_DWEXSTYLE);

	consoleHwnd = CreateWindowEx(CONSOLE_DWEXSTYLE, "EzGraphConsoleClass", "EzGraph Console",
		                         CONSOLE_DWSTYLE,
								 console_x, console_y,
								 cRect.right-cRect.left, cRect.bottom-cRect.top,
								 win_hwnd, NULL, hInstance, NULL);
	if (consoleHwnd != NULL){
		memset(&menuItemInfo, 0, sizeof(menuItemInfo));
		menuItemInfo.cbSize = sizeof(menuItemInfo);
		menuItemInfo.fMask = MIIM_STATE;
		menuItemInfo.fState = MFS_CHECKED;
		SetMenuItemInfo(mainMenu, mid_console, FALSE, &menuItemInfo);
		DrawMenuBar(win_hwnd);
		enableConsole = 1;
	}

	hdc = GetDC(consoleHwnd);
//	hpen_old = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(255,255,255)));
//  DeleteObject(hpen_old);
	SetTextColor(hdc, RGB(255, 255, 255));
	SetBkMode(hdc, TRANSPARENT);

    memset(&consoleFont, 0, sizeof(consoleFont));
	// [U\[XShiftJisłƑz肵Ă̂ŁA
        // ShiftJisɐݒ肵Ȃƕ
	consoleFont.lfCharSet = SHIFTJIS_CHARSET;
	consoleFont.lfPitchAndFamily = FIXED_PITCH;
	consoleFont.lfHeight = CONSOLE_FONTSIZE;


}

void _EzDestroyConsole(void){
	MENUITEMINFO menuItemInfo;

	SendMessage(consoleHwnd, WM_CLOSE, 0, 0);
	consoleHwnd = NULL;
	memset(&menuItemInfo, 0, sizeof(menuItemInfo));
	menuItemInfo.cbSize = sizeof(menuItemInfo);
	menuItemInfo.fMask = MIIM_STATE;
	menuItemInfo.fState = MFS_UNCHECKED;
	SetMenuItemInfo(mainMenu, mid_console, FALSE, &menuItemInfo);
	DrawMenuBar(win_hwnd);
	enableConsole = 0;
}


LRESULT CALLBACK ConsoleProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
	PAINTSTRUCT ps;
    HDC hdc = NULL;
    int i, ix;
//	char buf[16];
	HFONT hFont;

	switch (message) {
	case WM_PAINT:
		hdc = BeginPaint(consoleHwnd, &ps);
		hFont = CreateFontIndirect(&consoleFont);
		SelectObject(hdc, hFont);
		PatBlt(hdc, 0, 0, CONSOLE_WIDTH, CONSOLE_HEIGHT, BLACKNESS);
	 	ix = (console_tail+1) % CONSOLE_LINES;
		for (i = 0 ; i < CONSOLE_LINES ; i++){
//			sprintf(buf, "%2d", ix);
//			TextOut(hdc, 0, i*16, buf, strlen(buf));
			TextOut(hdc, CONSOLE_MARGIN, i*CONSOLE_FONTSIZE+CONSOLE_MARGIN,
				    console_text[ix], (int)strlen(console_text[ix]));
			ix = (ix + 1) % CONSOLE_LINES;
		}
		DeleteObject(hFont);
		EndPaint(consoleHwnd, &ps);
		return 0;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}

int EzOpenWindow(int width, int height){
    RECT wRect, cRect;
	HBRUSH hBrush;
	int i;

	client_width = width;
	client_height = height;
	GetWindowRect(win_hwnd, &wRect);
	GetClientRect(win_hwnd, &cRect);
	cRect.right = width;
	cRect.bottom = height + GetSystemMetrics(SM_CYSIZE);
	// o[W̓j[Ȃ̂ŁA3false
	AdjustWindowRect(&cRect, WINDOW_STYLE, FALSE);
	MoveWindow(win_hwnd, wRect.left, wRect.top, cRect.right-cRect.left, cRect.bottom-cRect.top, TRUE);

	// VEBhETCYŃItCrbg}bv蒼
	for (i = 0 ; i < 2 ; i++){
		if (buf_bmp[i] != NULL){
			DeleteObject(buf_bmp[i]);
			DeleteDC(buf_hdc[i]);
		}
		buf_hdc[i] = CreateCompatibleDC(win_hdc);
	   	buf_bmp[i] = CreateCompatibleBitmap(win_hdc, client_width, client_height);
		SelectObject(buf_hdc[i], buf_bmp[i]);
	}
	offScreen = 0;
	onScreen = 1;
//    draw_hdc = buf_hdc[offScreenBuf];
	// ----- eLXg֌W̏
	// eLXg̔wi͓߂
	SetBkMode(buf_hdc[0], TRANSPARENT);
	SetBkMode(buf_hdc[1], TRANSPARENT);

	// ftHg̐}``͓hԂȂ(Draw)Ȃ̂ŃuV𓧖ɂĂ
	// (Win32ł̓ftHgWHITE_BRUSHo^Ă)
	// hԂn(Fill)`͂̓sxA݂̕`F̃uVƌĕ`悷
	hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
	SelectObject(win_hdc, hBrush);
	SelectObject(buf_hdc[0], hBrush);
	SelectObject(buf_hdc[1], hBrush);
//	hbrush_old = SelectObject(buf_hdc, hbrush);
//    DeleteObject(hbrush_old);

	// ----- eLXg֌W̏
	// eLXg̔wi͓߂
	SetBkMode(win_hdc, TRANSPARENT);
	SetBkMode(buf_hdc[0], TRANSPARENT);
	SetBkMode(buf_hdc[1], TRANSPARENT);
    memset(&logFont, 0, sizeof(logFont));
	// [U\[XShiftJisłƑz肵Ă̂ŁA
        // ShiftJisɐݒ肵Ȃƕ
	logFont.lfCharSet = SHIFTJIS_CHARSET;
	// Ƃ肠IWił̃ftHgɍ킹Œ蕝tHgɂĂ
	logFont.lfPitchAndFamily = FIXED_PITCH;
	EzSetFontSize(EzDefaultFontSize);

        // EzGraph͕`F̏l
	EzSetColorByRGB(255,255,255);

    // ItCrbg}bvɕ`悵ȂꍇAOnPaintŐVEBhË悪NAȂ߁A
	// IEzClearǂł
	EzClear();
	return 0;
}

int EzDrawPoint(int x, int y){
	_EzDrawPoint(win_hdc, x, y);
	_EzDrawPoint(buf_hdc[onScreen], x, y);
	return 0;
}
int EzDrawPointB(int x, int y){
	_EzDrawPoint(buf_hdc[offScreen], x, y);
	return 0;
}
int _EzDrawPoint(HDC hdc, int x, int y){
	SetPixel(hdc, x, y, pen_color);
	return 0;
}

int EzDrawLine(int x1, int y1, int x2, int y2){
	_EzDrawLine(win_hdc, x1, y1, x2, y2);
	_EzDrawLine(buf_hdc[onScreen], x1, y1, x2, y2);
	return 0;
}
int EzDrawLineB(int x1, int y1, int x2, int y2){
	_EzDrawLine(buf_hdc[offScreen], x1, y1, x2, y2);
	return 0;
}
int _EzDrawLine(HDC hdc, int x1, int y1, int x2, int y2){
	MoveToEx(hdc, x1, y1, NULL);
	LineTo(hdc, x2, y2);
	// LineTo͏I_`悵Ȃ̂ŕʓrI_`
	SetPixel(hdc, x2, y2, pen_color);
	return 0;
}

int EzDrawBox(int x1, int y1, int x2, int y2){
	_EzDrawBox(win_hdc, x1, y1, x2, y2);
	_EzDrawBox(buf_hdc[onScreen], x1, y1, x2, y2);
	return 0;
}
int EzDrawBoxB(int x1, int y1, int x2, int y2){
	_EzDrawBox(buf_hdc[offScreen], x1, y1, x2, y2);
	return 0;
}
int _EzDrawBox(HDC hdc, int x1, int y1, int x2, int y2){
	// Rectangle͉ӁEEӂ܂܂Ȃ
	Rectangle(hdc, x1, y1, x2+1, y2+1);
	return 0;
}


int EzFillBox(int x1, int y1, int x2, int y2){
    _EzFillBox(win_hdc, x1, y1, x2, y2);
    _EzFillBox(buf_hdc[onScreen], x1, y1, x2, y2);
	return 0;
}
int EzFillBoxB(int x1, int y1, int x2, int y2){
    _EzFillBox(buf_hdc[offScreen], x1, y1, x2, y2);
	return 0;
}
int _EzFillBox(HDC hdc, int x1, int y1, int x2, int y2){
	InitFill();
	BeginFill();
	_EzDrawBox(hdc, x1, y1, x2, y2);
	EndFill();
	return 0;
}

int EzDrawCircle(int x, int y, unsigned int r){
	_EzDrawCircle(win_hdc, x, y, r);
	_EzDrawCircle(buf_hdc[onScreen], x, y, r);
	return 0;
}
int EzDrawCircleB(int x, int y, unsigned int r){
	_EzDrawCircle(buf_hdc[offScreen], x, y, r);
	return 0;
}
int _EzDrawCircle(HDC hdc, int x, int y, unsigned int r){
	int left, top, right, bottom;
	left = x - r;
	top = y - r;
	right = x + r;
	bottom = y + r;
	// Ellipse͋`(left, top)-(right, bottom)̓()~`
	// !!!㉺E̕ӂ܂ނǂv`FbN
    Ellipse(hdc, left, top, right, bottom);
	return 0;
}

int EzFillCircle(int x, int y, unsigned int r){
	_EzFillCircle(win_hdc, x, y, r);
	_EzFillCircle(buf_hdc[onScreen], x, y, r);
	return 0;
}
int EzFillCircleB(int x, int y, unsigned int r){
	_EzFillCircle(buf_hdc[offScreen], x, y, r);
	return 0;
}
int _EzFillCircle(HDC hdc, int x, int y, unsigned int r){
	InitFill();
	BeginFill();
	_EzDrawCircle(hdc, x, y, r);
	EndFill();
	return 0;
}

int EzDrawArc(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
    _EzDrawArc(win_hdc, x, y, rx, ry, t1, t2);
    _EzDrawArc(buf_hdc[onScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int EzDrawArcB(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
    _EzDrawArc(buf_hdc[offScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int _EzDrawArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
	int left, top, right, bottom;
	int sx, sy, ex, ey;
	_conv_arc_param(x, y, rx, ry, t1, t2, &left, &top, &right, &bottom, &sx, &sy, &ex, &ey);
    Arc(hdc, left, top, right, bottom, sx, sy, ex, ey);
	return 0;
}

int EzFillArc(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
    _EzFillArc(win_hdc, x, y, rx, ry, t1, t2);
    _EzFillArc(buf_hdc[onScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int EzFillArcB(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
    _EzFillArc(buf_hdc[offScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int _EzFillArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
	int left, top, right, bottom;
	int sx, sy, ex, ey;
	InitFill();
	_conv_arc_param(x, y, rx, ry, t1, t2, &left, &top, &right, &bottom, &sx, &sy, &ex, &ey);
	BeginFill();
    Pie(hdc, left, top, right, bottom, sx, sy, ex, ey);
	EndFill();
	return 0;
}

void _conv_arc_param(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2,
					 int *left, int *top, int *right, int *bottom, int *sx, int *sy, int *ex, int *ey)
{
	// Arc/Pie͋`(left, top)-(right, bottom)̓()~̌ʂ`
	*left = x - rx;
	*top = y - ry;
	*right = x + rx;
	*bottom = y + ry;
	// t1, t2͊JnpEIp(P:xAE0ƂĔv)
	// Pie̊JnEIʒu͒S_(sx, sy), (ex, ey)֐L΂Ɖ~̌_Ŏw肷
	*sx = (int)(cos(t1*PI/180)*1000) + x;
	*sy = -(int)(sin(t1*PI/180)*1000) + y;
	*ex = (int)(cos(t2*PI/180)*1000) + x;
	*ey = -(int)(sin(t2*PI/180)*1000) + y;
}

int EzFillPolygon(int num, int *poly){
	_EzFillPolygon(win_hdc, num, poly);
	_EzFillPolygon(buf_hdc[onScreen], num, poly);
	return 0;
}
int EzFillPolygonB(int num, int *poly){
	_EzFillPolygon(buf_hdc[offScreen], num, poly);
	return 0;
}
int _EzFillPolygon(HDC hdc, int num, int *poly){
	InitFill();
	BeginFill();
	if (sizeof(int)*2 == sizeof(POINT)){
		Polygon(hdc, (POINT*)poly, num);
	}
	else {
		// !!! intlong̃TCYvȂꍇ́ApolyPOINT̔zɃRs[ĂPolygon()
	}
	EndFill();
	return 0;
}

int EzDrawString(int x, int y, char *s){
	_EzDrawString(win_hdc, x, y, s);
	_EzDrawString(buf_hdc[onScreen], x, y, s);
	return 0;
}
int EzDrawStringB(int x, int y, char *s){
	_EzDrawString(buf_hdc[offScreen], x, y, s);
	return 0;
}
int _EzDrawString(HDC hdc, int x, int y, char *s){
	HFONT hFont;
    // tHgTCY͂̓sxHFONT쐬Đݒ
    hFont = CreateFontIndirect(&logFont);
	SelectObject(hdc, hFont);
	TextOut(hdc, x, y-fontSize, s, (int)strlen(s));
	DeleteObject(hFont);
	return 0;
}

int EzClear(void){
	_EzClear(win_hdc);
	_EzClear(buf_hdc[onScreen]);
	return 0;
}

// EzClearB݂͑ȂA
// EzGraphŃItCrbg}bvNAł悤ɁAwin, bufɑΉĂ
int _EzClear(HDC hdc){
    // PatBltBLACKNESSnƁAuVyݒ肵ȂĂœhԂ
	PatBlt(hdc, 0, 0, client_width, client_height, BLACKNESS);
	return 0;
}

int EzShowBuffer(void){
	// _uobt@̃IXN[^ItXN[ĐVItXN[NA
	onScreen = offScreen;
	offScreen = 1-onScreen;
//	draw_hdc = buf_hdc[offScreen];
	_EzClear(buf_hdc[offScreen]);
	InvalidateRect(win_hwnd, NULL, FALSE);    
//	UpdateWindow(win_hwnd);
//	showBufferF = -1;
	return 0;
}

// !!! Ƃ肠XN[AItCrbg}bvƂFݒ肵Ă
int EzSetColorByRGB(unsigned short r, unsigned short g, unsigned short b){
	HPEN hpen_old;
	// pen_colorSetPixelłĝŁAO[oɒlێKv
	pen_color = RGB(r, g, b);
	hpen_old = SelectObject(win_hdc, CreatePen(PS_SOLID, 1, pen_color)); 
    DeleteObject(hpen_old);
	// !!! IXN[obt@win_hdcւ̓]Ȃ̂ŁAFݒ͕svȂ
	hpen_old = SelectObject(buf_hdc[onScreen], CreatePen(PS_SOLID, 1, pen_color)); 
    DeleteObject(hpen_old);
	hpen_old = SelectObject(buf_hdc[offScreen], CreatePen(PS_SOLID, 1, pen_color)); 
    DeleteObject(hpen_old);
	// Win32ł̓eLXg̐F͕ʓrw肪Kv
	SetTextColor(win_hdc, pen_color);
	SetTextColor(buf_hdc[onScreen], pen_color);
	SetTextColor(buf_hdc[offScreen], pen_color);
	return 0;
}

int EzSetColorByName(char *s){
	char name[128];
	int i;

	// name2rgb͏\L
	// [U啶ŖOw肵ꍇɔA
        // Ăr
	_downcase(s, name);
	// ݂͐`T
	// name2rgb͎Ă̂ŁAEzGraphname2rgb
        // Ƀ\[gĂ񕪒T
	for (i = 0 ; i < name2rgb_num ; i++){
		if (strcmp(name, _EzName2RGB[i].name) == 0){
			EzSetColorByRGB(_EzName2RGB[i].r, _EzName2RGB[i].g, _EzName2RGB[i].b);
			return 0;
		}
	}
	return -1;
}

// !!! o[W͂ȂɂȂ
int EzSetFont(char *s){
	return 0;
}

int EzSetFontSize(int i){
    fontSize = i;
	logFont.lfHeight = fontSize;
    return 0;
}

int EzSetMouseHandler(EzMouseHandler func){
	mouseh_func = func;
	return 0;
}

int EzSetMouseReleaseHandler(EzMouseHandler func){
	mouse_releaseh_func = func;
	return 0;
}

int EzSetKeyHandler(EzKeyHandler func){
	keyh_func = func;
	return 0;
}

int EzSetKeyReleaseHandler(EzKeyHandler func){
	key_releaseh_func = func;
	return 0;
}

// !!! oOFVXeN49.7GetTickCount̕Ԃl0ɖ߂̂
// ̋E܂ŃvO𑖂点ƃnOH
int EzSetTimerHandler(EzTimerHandler func, unsigned long ms){
	DWORD currentTime;
	currentTime= GetTickCount();
	timerh_nexttime = currentTime += ms;
	timerh_func = func;
	timerh_ms = ms;
//        if (func == NULL && forceOffline){
//            InvalidateRect(win_hwnd, NULL, FALSE);
////            EzShowBuffer();
//        }
	return 0;
}

void EzEventLoop(void){
	MSG msg;
//    EzTimerHandler tfunc;
	DWORD currentTime;

	while(1){
		if (mouseh_func != NULL && event_mouse.flag != 0){
			event_mouse.flag = 0;
			mouseh_func(event_mouse.x, event_mouse.y, event_mouse.button);
		}
		if (mouse_releaseh_func != NULL && event_mouse_release.flag != 0){
			event_mouse_release.flag = 0;
			mouse_releaseh_func(event_mouse_release.x, event_mouse_release.y,
								event_mouse_release.button);
		}
		// 1msɃL[down/upCɔA邢͕̃L[down\
		// ̂ŁAL[Cxg̓L[ɓo^ĂɃnhĂяoĂ
		// !!! }EX{^lɏ悢H
		if (event_key_queue_head != event_key_queue_tail){
			if (event_key_queue[event_key_queue_head].is_down){
				if (keyh_func != NULL){
					keyh_func(event_key_queue[event_key_queue_head].key);
				}
			}
			else {
				if (key_releaseh_func != NULL){
					key_releaseh_func(event_key_queue[event_key_queue_head].key);
				}
			}
			event_key_queue_head = (event_key_queue_head + 1) % EVENT_QUEUE_SIZE;
		}
		if (timerh_func != NULL && GetTickCount() >= timerh_nexttime){
			// ̃^C}荞ݎԂtimer_msɎ̊荞݂̂
			// timerh_funcĂяoOnexttimevZĂ
			// timerh_func̏vԂtimerh_ms蒷ΏN
			// timerh_funcďonexttimevZΏ͋NȂ
			// 荞݊Ԋutimerh_func̏vԂZ(ŜɒxȂ)
			currentTime= GetTickCount();
			timerh_nexttime = currentTime += timerh_ms;
			timerh_func();
//                        if (forceOffline){
//                            InvalidateRect(win_hwnd, NULL, FALSE);
//                            // EzShowBuffer();
//                        }
		}
		if (exitF){
			return;
		}
		// GetMessage̓ubLOȂ̂PeekMessageg
		while (PeekMessage(&msg,NULL,0,0, PM_REMOVE)){
			// PeekMessage͕ԂlWM_QUITǂfłȂ̂
			// IɃ`FbN
			if (msg.message == WM_QUIT){
				return;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		Sleep(1);
	}
}


void EzExitEventLoop(void){
	exitF = -1;
}


int EzQueryKeymap(char keys[32]){
	memcpy(keys, ezkey_map, sizeof(char)*32);
	// !!! Ƃ肠A0ԂƂɂ
	// !!! IWiłɏ]ȂAEBhẼtH[JXOĂAkeysׂ0ɂ
	return 0;
}


int EzIsKeyPress(char keys[32], int code){
    code = code & 0xff;
	if ((keys[(code >> 3)] & (1 << (code & 0x07))) != 0){
		return -1;
	}
	else {
		return 0;
	}
}

// o[ẂAJ[e[u͕̕ƂA256F܂łȂ
EzImage EzReadXPM(char **xpm){
	EzImage img;
	char c, dummy;
	char color_name[256];
	int i, x, y, color, width, height, color_num, len;
	COLORREF color_table[256+1] = {0x00000000};
	HDC image_hdc, mask_hdc;

	if (sscanf(xpm[0], "%d %d %d %d", &width, &height, &color_num, &len) != 4){
		img.height = 0;
		return img;
	}
	img.width = width;
	img.height = height;
	// !!! ێpz̑傫𒴂AƂ肠sĂ
	if (xpm_bmp_num+2 > XPM_MAX*2){
		img.height = 0;
		return img;
	}
	img.image = CreateCompatibleBitmap(win_hdc, width, height);
	xpm_bmp[xpm_bmp_num++] = img.image;
	img.mask = CreateCompatibleBitmap(win_hdc, width, height);
	xpm_bmp[xpm_bmp_num++] = img.mask;

	for (i = 0 ; i < color_num ; i++){
		if (sscanf(xpm[1+i], "%c %c #%x", &c, &dummy, &color) == 3){
			color_table[c] = color;
		}
		else if (sscanf(xpm[1+i], "%c %c %s", &c, &dummy, color_name) == 3){
			if (strcmp(color_name, "None") == 0){
				color_table[c] = -1;
			}
			else {
				// FRGBɕϊăe[uɊi[
			}
		}
	}

	image_hdc = CreateCompatibleDC(win_hdc);
	mask_hdc = CreateCompatibleDC(win_hdc);
	SelectObject(image_hdc, img.image);
	SelectObject(mask_hdc, img.mask);
	for (y = 0 ; y < height ; y++){
		for (x = 0 ; x < width ; x++){
			color = color_table[xpm[y+color_num+1][x]];
			if (color == -1){
				SetPixel(image_hdc, x, y, 0x000000);	
				SetPixel(mask_hdc, x, y, 0xffffff);	
			}
			else {
				SetPixel(image_hdc, x, y, RGB2COLORREF(color));	
				SetPixel(mask_hdc, x, y, 0x00000);	
			}
		}
	}

	DeleteDC(image_hdc);
	DeleteDC(mask_hdc);

	return img;
}

void _EzDeleteImage(void){
	int i;
	for (i = 0 ; i < xpm_bmp_num ; i++){
		DeleteObject(xpm_bmp[i]);
	}
}

void EzPut(int x, int y, EzImage img){
	_EzPut(win_hdc, x, y, img);
	_EzPut(buf_hdc[onScreen], x, y, img);
}
void EzPutB(int x, int y, EzImage img){
	_EzPut(buf_hdc[offScreen], x, y, img);
}
void _EzPut(HDC hdc, int x, int y, EzImage img){
	HDC image_hdc, mask_hdc;

	image_hdc = CreateCompatibleDC(hdc);
	mask_hdc = CreateCompatibleDC(hdc);
	SelectObject(image_hdc, img.image);
	SelectObject(mask_hdc, img.mask);
	BitBlt(hdc, x, y, img.width, img.height, mask_hdc, 0, 0, SRCAND);
	BitBlt(hdc, x, y, img.width, img.height, image_hdc, 0, 0, SRCPAINT);
	DeleteDC(image_hdc);
	DeleteDC(mask_hdc);
}

long EzGetTimeLeft(void){
	return timerh_nexttime - GetTickCount();
}

void _backSlash2Slash(char *str){
	while (*str != '\0'){
		if (*str == '\\'){
			*str = '/';
		}
        str ++;
	}
}

void _slash2BackSlash(char *str){
	while (*str != '\0'){
		if (*str == '/'){
			*str = '\\';
		}
        str ++;
	}
}

void _downcase(char *src, char *result){
	while (*src != '\0'){
		*result = tolower(*src);
		src ++;
		result ++;
	}
	*result = '\0';
}


int _EzPrintf(char *fmt, ...){
	va_list ap;
	char buf[PRINTF_MAX_LEN+1];

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
//	vsnprintf(buf, PRINTF_MAX_LEN, fmt, ap);
    va_end(ap);
	// o͓eӂꂽꍇARs[ɃI[oȂ悤AkĂ
	buf[PRINTF_MAX_LEN] = 0;
	return _EzPutLine(buf);
}

int _EzPuts(char *s){
	char buf[PRINTF_MAX_LEN+1];

	if (strlen(s) >= PRINTF_MAX_LEN) return -1;

	sprintf(buf, "%s\n", s);
	return _EzPutLine(buf);
}


_EzPutLine(char *line){
	char *src, *dest;
	// R\[EBhEJĂꍇ̂ݍĕ`v
	if (consoleHwnd){
		InvalidateRect(consoleHwnd, NULL, FALSE);   
	}
	src = line;
	dest = console_text[console_tail] + console_len;
	while (*src != '\0'){
		if (*src == '\n'){
			*dest = '\0';
		    console_tail = (console_tail + 1) % CONSOLE_LINES;
			console_len = 0;
			dest = console_text[console_tail];
			*dest = '\0';
			return 0;
		}
	    *dest = *src;
		src ++;
		dest ++;
		console_len ++;
		if (console_len == CONSOLE_LENGTH){
  		    console_text[console_tail][CONSOLE_LENGTH] = '\0';
		    console_tail = (console_tail + 1) % CONSOLE_LINES;
			console_len = 0;
			dest = console_text[console_tail];
		}
	}
	*dest = '\0';
	return 0;
}




